package com.mcapraro.ld29
{
	import flash.media.Sound;
	import flash.media.SoundChannel;
	import flash.media.SoundTransform;
	import citrus.objects.platformer.box2d.Crate;

	/**
	 * @author Michelangelo Capraro (m&#64;mcapraro.com)
	 */
	public class Nut extends Crate
	{
		private var soundChannel:SoundChannel;
		private var rollingSound:Sound;
		public function Nut(name:String, params:Object = null)
		{
			super(name, params);
		}

		override protected function defineFixture():void
		{
			super.defineFixture();
			_fixtureDef.density = 1.3;
			_fixtureDef.restitution = 0.8;
			_fixtureDef.friction = 0.1;
			
			view = Assets.assets.getTexture("walnut");
		}


		override public function update(timeDelta:Number):void 
		{
			super.update(timeDelta);
			if (velocity[0] != 0 && soundChannel == null) {
				trace("rolling");
				rollingSound = new Assets.rolling_sound();
				soundChannel = rollingSound.play(0, 99999);
				trace(soundChannel);
			}
			
			if (velocity[0] == 0 && soundChannel != null) {
				stopSound();
			}
		}
		
		public function stopSound():void
		{
			if (soundChannel != null) {
				soundChannel.stop();
				soundChannel = null;
				rollingSound = null;
			}
		}

		override public function destroy():void
		{
			super.destroy();
			rollingSound = null;
			soundChannel = null;
			view = null;
		}


	}
}
