package com.mcapraro.ld29
{
	import Box2D.Collision.Shapes.b2PolygonShape;
	import Box2D.Dynamics.b2Body;
	import Box2D.Collision.Shapes.b2CircleShape;
	import Box2D.Common.Math.b2Vec2;
	import Box2D.Dynamics.Contacts.b2Contact;
	import org.osflash.signals.Signal;
	import citrus.objects.platformer.box2d.Platform;

	/**
	 * @author Michelangelo Capraro (m&#64;mcapraro.com)
	 */
	public class ShiftingPlatform extends Platform
	{

		/**
		 * Dispatches on first contact with the sensor.
		 */
		public var onBeginContact:Signal;

		public function ShiftingPlatform(name:String, params:Object = null)
		{
			_beginContactCallEnabled = true;
			
			super(name, params);

			onBeginContact = new Signal(b2Contact);
		}

		override protected function createShape():void
		{
			super.createShape();
			
			//b2PolygonShape(_shape).SetAsBox(_width / 2, _height / 2 / 2);
			b2PolygonShape(_shape).SetAsOrientedBox(_width / 2, _height / 4, new b2Vec2(0, _height / 4), 0);
		}
		
		
		override protected function defineFixture():void
		{
			super.defineFixture();
		}
		
		override protected function createFixture():void
		{
			super.createFixture();
			
			_fixtureDef.shape = _shape;
			_fixture = _body.CreateFixture(_fixtureDef);

			// create the circle shape at the top
			_shape = new b2CircleShape();
			b2CircleShape(_shape).SetRadius(_width / 2);
			b2CircleShape(_shape).SetLocalPosition(new b2Vec2(0, (_width / 2) - (_height / 2)));
			_fixtureDef.shape = _shape;
			_fixture = _body.CreateFixture(_fixtureDef);	
		}

		override protected function defineBody():void 
		{
			super.defineBody();
			_bodyDef.type = b2Body.b2_staticBody;
			
		}


		override public function handleBeginContact(contact:b2Contact):void {
			onBeginContact.dispatch(contact);
		}


	}
}
