package com.mcapraro.ld29
{
	import flash.utils.getTimer;
	import com.greensock.TweenMax;
	import dragonBones.Armature;
	import dragonBones.objects.XMLDataParser;
	import dragonBones.factorys.StarlingFactory;
	import citrus.objects.platformer.box2d.Hero;

	/**
	 * @author Michelangelo Capraro (m&#64;mcapraro.com)
	 */
	public class VoleHero extends Hero
	{
		private var _factory:StarlingFactory;
		private var _voleArmature:Armature;
		private var _blinkTimer:int;
		private var _cleanTimer:int;
		private var useAlternateIdle:Boolean;

		public function VoleHero(name:String, params:Object = null)
		{
			super(name, params);
			
			acceleration = 1.5;
			maxVelocity = 8;
			jumpHeight = 15;
			jumpAcceleration = 0.6;
			touchable = false;

		}
		
		override public function initialize(poolObjectParams:Object = null):void
		{
			 super.initialize(poolObjectParams);

			_factory = new StarlingFactory();
			_factory.addSkeletonData(XMLDataParser.parseSkeletonData(XML(new Assets.vole_skeleton())), "vole_skeleton");
			_factory.addTextureAtlas(Assets.assets.getTextureAtlas("parts"), "vole_textures");
			_voleArmature = _factory.buildArmature("Vole", null, "vole_skeleton", "vole_textures"); //Neds to be the name of the armature in the DragonBones skeleton XML
			
			
			// set the view of the hero to this artmature
			_view = _voleArmature;
			offsetX -= 30;
			offsetY -= 50;
		}
		
		
		override protected function updateAnimation():void
		{
			super.updateAnimation();
			
			// randomly blink the eye
			if (Math.random() > .9 && _blinkTimer < getTimer() - 3000) {
				
				if (_voleArmature) {
					_voleArmature.getBone("VoleEye").visible = false;
					TweenMax.delayedCall(.1, function():void {
						_voleArmature.getBone("VoleEye").visible = true;
					});
				}
				_blinkTimer = getTimer();
			}
			
			// randomly clean himself
			if (Math.random() > .9 && _cleanTimer < getTimer() - 6000) {
				useAlternateIdle = true;
				TweenMax.delayedCall(2, function():void {
					useAlternateIdle = false;
				});
				_cleanTimer = getTimer();
			}
			
			if (useAlternateIdle && _animation == "idle") _animation = "idle2";
		}
		
		
		override public function destroy():void
		{
			super.destroy();
		}
	}
}
