package com.mcapraro.ld29
{
	import Box2D.Common.Math.b2Vec2;
	import Box2D.Dynamics.b2Body;
	import citrus.utils.objectmakers.ObjectMaker2D;
	import citrus.objects.platformer.box2d.Hero;
	import citrus.physics.box2d.Box2D;
	import org.osflash.signals.Signal;
	import citrus.core.starling.StarlingState;

	/**
	 * @author Michelangelo Capraro (m&#64;mcapraro.com)
	 */
	public class Level1State extends StarlingState
	{
		private var _firstRun:Boolean;
		public var onRestart:Signal;
		private var _box2D:Box2D;
		private var _level:Level1;
		private var _hero:Hero;
		private var includes:Array;
		private var _magnetized:Boolean;
		private var _block:MetalBlock;
		
		public function Level1State(firstRun:Boolean = false)
		{
			trace("Level1State created");
			super();
			
			includes = [MagnetHero, MetalBlock];
			
			_level = new Level1();
			
			_firstRun = firstRun;
			
			onRestart = new Signal();
		}

		override public function initialize():void
		{
			super.initialize();
			
			_box2D = new Box2D("box2D");
			_box2D.visible = true;
			add(_box2D);
			
			setupMap();
			setupMagnet();
			
			start();
		}


		private function setupMagnet():void
		{
			_hero = getObjectByName("hero") as MagnetHero;
			_block = getObjectByName("block") as MetalBlock;
		}

		private function setupMap():void
		{
			// create the physics bodies from the SWF
			ObjectMaker2D.FromMovieClip(_level);
		}

		private function start():void
		{
			
		}
		
		
		override public function update(timeDelta:Number):void
		{
			super.update(timeDelta);
			
			_magnetized = true;
			if (_magnetized) {
				//b2Body(_block.getBody()).SetAwake(true);
				//_block.x = _hero.x;
				var delta:Number = (_hero.x - _block.x);
				if (delta != 0) {
					var impulse:b2Vec2 =  new b2Vec2(delta, 0);
					var blockBody:b2Body = _block.getBody();
					blockBody.ApplyForce(impulse, blockBody.GetPosition());
				}
			}
		}


		override public function destroy():void
		{
			super.destroy();
		}
	}
}
